<?php
/* =====================================================================
 * Dieses Skript ist Teil von "Wetter-Analyse in Dekaden (WADE)"
 * Von "Trixi aus Witten/NRW" - http://taw-wade.kilu.de/
 *                 Version 12.09.01 - Build 21.09.2012
 * Lizenziert unter "Namensnennung-Weitergabe unter gleichen Bedingungen
 * 3.0 Deutschland (CC BY-SA 3.0)"
 *                 ==> http://creativecommons.org/licenses/by-sa/3.0/de/
 *
 * Diese Software ist FREIE SOFTWARE und wird mit der Hoffnung, daß sie
 * nützlich sein könnte, zur Verfügung gestellt, jedoch OHNE JEDE
 * GEWÄHRLEISTUNG. Auch nicht für eine ALLGEMEINE GEBRAUCHSTAUGLICHKEIT
 * oder Stabilität für die NUTZUNG ZU EINEM BESTIMMTEN ZWECK. Die freie
 * Software, von der hier die Rede sein soll, ist kein "Freibier",
 * sondern sie gibt dir die Freiheiten
 *
 *   o  die Software für einen beliebigen Zweck auszuführen
 *   o  die Funktionsweise der Software zu studieren und sie an deine
 *      eigenen Bedürfnisse anzupassen
 *   o  Kopien der Software weiterzugeben
 *   o  sowie die Software zu verbessern und diese Verbesserungen zu
 *      veröffentlichen.
*/
// @module export "\t\tExportiert Rohdaten in ein anderes Format\n"
$DA->KonsolenAusgabe('Beginne mit der Ausführung von '.basename(__FILE__),1);
	if ( !is_dir($einstellungen['zwischenspeicher']['speicher_pfad']) )
	$DA->KonsolenAusgabe('Das Verzeichnis für den Zwischenspeicher existiert nicht',-1);
	if ( strlen($DA->cli_parameter['station']) < 4 )
	$DA->KonsolenAusgabe('Es wurde keine Station mit "--station=[name]" angegeben',-1);
	if ( !isset($einstellungen['daten'][$DA->cli_parameter['station']]) )
	$DA->KonsolenAusgabe('Diese Station befindet sich nicht in der Konfiguration',-1);
	if ( !in_array($einstellungen['export']['datenreihe_auswerten'],$DA->datenreihen) )
	$DA->KonsolenAusgabe('Es existiert keine Datenreihe mit dem Namen "'.$einstellungen['export']['datenreihe_auswerten'].'"',-1);
	if ( $DA->cli_parameter['vergleich'] === '' )
	$DA->KonsolenAusgabe('Es wurde kein Vergleichszeitraum mit "--vergleich=[jahre]" angegeben',-1);

$dekaden_auswahl = array();
$daten_temp = explode(',',$einstellungen['export']['dekaden_auswahl']);
	if ( $daten_temp[0] === '*' ){
		for ( $m = 1 ; $m <= 12 ; $m++ ){
			for ( $d = 1 ; $d <= 3 ; $d++ )
			$dekaden_auswahl[] = $m.'/'.$d;
		}
	}
	else{
		foreach ( $daten_temp as $wert ){
		preg_match('|^([a-z0-9]{1,3})[^a-z0-9]+([123\*]{1})$|iD',$wert,$wert);
			if ( is_array($wert) && sizeof($wert) === 3 ){
			$monat = $DA->StrMonatNachZahl($wert[1]);
				if ( $monat === 0 )
				continue;
				if ( $wert[2] === '*' ){
				$dekaden_auswahl[] = $monat.'/1';
				$dekaden_auswahl[] = $monat.'/2';
				$dekaden_auswahl[] = $monat.'/3';
				}
				else
				$dekaden_auswahl[] = $monat.'/'.(int)$wert[2];
			}
		}
	}
unset($wert,$monat,$m,$d);

$DA->KonsolenAusgabe('Berechne die Daten für den Export',2);

$datensatz = $DA->HoleRoheDatenDerJahre($DA->cli_parameter['station'],$DA->cli_parameter['vergleich']);
$daten_temp = array();

	foreach ( $datensatz as $daten ){
	$dekade = $DA->ErmittleDekade($daten['tag']);
	$schluessel = $daten['monat'].'/'.$dekade;
		if ( in_array($schluessel,$dekaden_auswahl) ){
			if ( !isset($daten_temp[$daten['jahr']]) )
			$daten_temp[$daten['jahr']] = array();
			if ( !isset($daten_temp[$daten['jahr']][$schluessel]) )
			$daten_temp[$daten['jahr']][$schluessel] = array();
		$DA->UngueltigeDatensaetzeEntfernen($daten,$daten['jahr'].','.$schluessel.'::'.$einstellungen['export']['datenreihe_auswerten']);
		$daten_temp[$daten['jahr']][$schluessel][] = $daten[$einstellungen['export']['datenreihe_auswerten']];
		}
	}

$DA->KonsolenAusgabe('Datenbearbeitung beendet',1);

$DA->KonsolenAusgabe('Erstellen des Reports vom Typ '.$DA->cli_parameter['typ'],1);
define('LF',"\r\n"); // \r\n für bessere Lesbarkeit unter Windows beim Standardeditor
$report = '';

	switch ( $DA->cli_parameter['typ'] ){
	case 'text':
	$report .= 'EXPORT FÜR DEN ZEITRAUM DER JAHRE '.$DA->cli_parameter['vergleich'].LF;
	$report .= 'Erstellt am '.strftime(WADE_FDATE,time()).LF;
	$report .= 'Name der Station: '.$einstellungen['daten'][$DA->cli_parameter['station']]['name'].
		' ('.$einstellungen['daten'][$DA->cli_parameter['station']]['code'].')'.LF;
	$report .= 'Daten-Quelle: '.$einstellungen['daten'][$DA->cli_parameter['station']]['quelle'].LF.LF;
	$report .= 'Die Werte für "'.$einstellungen['export']['datenreihe_auswerten'].'" in den Dekaden "'.$einstellungen['export']['dekaden_auswahl'].
		'" wurde mit "'.$einstellungen['export']['konsolidierung_funktion'].'" zusammengerechnet'.LF.LF;
		if ( !empty($einstellungen['export']['kommentar']) )
		$report .= $einstellungen['export']['kommentar'].LF.LF;
	$report .= '      ';
		foreach ( $dekaden_auswahl as $dekade ){
		$dekade = explode('/',$dekade);
		$dekade[0] = $DA->StrMonatNachName($dekade[0]);
		$report .= str_pad(implode('/',$dekade),8,' ',STR_PAD_RIGHT);
		}
	$report .= LF;
		foreach ( $daten_temp as $jahr=>$datensatz ){
		$report .= $jahr.'  ';
			foreach ( $datensatz as $dekade=>$daten ){
				if ( $einstellungen['export']['konsolidierung_funktion'] === 'mittelwert' )
				$wert = array_sum($daten)/sizeof($daten);
				elseif ( $einstellungen['export']['konsolidierung_funktion'] === 'summe' )
				$wert = array_sum($daten);
				$report .= str_pad(number_format($wert,1,',','.'),8,' ',STR_PAD_RIGHT);
			}
		$report .= LF;
		}
	$report .= LF.LF;
		if ( strlen($einstellungen['report']['lizenz_text']) > 20 )
		$report .= $einstellungen['report']['lizenz_text'];
		if ( strlen($einstellungen['report']['lizenz_uri']) > 8 )
		$report .= LF.$einstellungen['report']['lizenz_uri'].LF.LF;
	break;

	case 'csv':
	$report .= '"",';
		foreach ( $dekaden_auswahl as $dekade ){
		$dekade = explode('/',$dekade);
		$dekade[0] = $DA->StrMonatNachName($dekade[0]);
		$report .= '"'.implode('/',$dekade).'",';
		}
	$report = substr($report,0,-1).LF;
		foreach ( $daten_temp as $jahr=>$datensatz ){
		$report .= '"'.$jahr.'",';
				foreach ( $datensatz as $dekade=>$daten ){
					if ( $einstellungen['export']['konsolidierung_funktion'] === 'mittelwert' )
					$wert = array_sum($daten)/sizeof($daten);
					elseif ( $einstellungen['export']['konsolidierung_funktion'] === 'summe' )
					$wert = array_sum($daten);
				$report .= '"'.number_format($wert,1,',','.').'",';
				}
		$report = substr($report,0,-1).LF;
		}
	break;

	case 'html':
	$report .= '<!DOCTYPE html>'.LF;
	$report .= '<html>'.LF;
	$report .= '<head>'.LF;
	$report .= '<meta http-equiv="content-type" content="text/html;charset=utf-8"></meta>'.LF;
	$report .= '<style type="text/css">.kopf { font-weight: bold; }
		.hell { background-color: #ccc; } .dunkel { background-color: #aaa; }
		.hell:hover, .dunkel:hover { background-color: #ffa; }</style>'.LF;
	$report .= '<body>'.LF;
	$report .= '<h1>EXPORT FÜR DEN ZEITRAUM DER JAHRE '.$DA->cli_parameter['vergleich'].'</h1>'.LF;
	$report .= '<p>Erstellt am '.strftime(WADE_FDATE,time()).'<br />'.LF;
	$report .= 'Name der Station: '.$einstellungen['daten'][$DA->cli_parameter['station']]['name'].
		' ('.$einstellungen['daten'][$DA->cli_parameter['station']]['code'].')<br />'.LF;
	$report .= 'Daten-Quelle: '.$einstellungen['daten'][$DA->cli_parameter['station']]['quelle'].'<br /><br />'.LF;
	$report .= 'Die Werte für "'.$einstellungen['export']['datenreihe_auswerten'].'" in den Dekaden "'.$einstellungen['export']['dekaden_auswahl'].
		'" wurde mit "'.$einstellungen['export']['konsolidierung_funktion'].'" zusammengerechnet</p>'.LF.LF;
		if ( !empty($einstellungen['export']['kommentar']) )
		$report .= '<p>'.$einstellungen['export']['kommentar'].'</p>'.LF;

	$report .= '<table>'.LF;
	$report .= '<tr class="kopf"><td>Jahr</td>'.LF;
		foreach ( $dekaden_auswahl as $dekade ){
		$dekade = explode('/',$dekade);
		$dekade[0] = $DA->StrMonatNachName($dekade[0]);
		$report .= '<td>'.implode('/',$dekade).'</td>'.LF;
		}
	$report .= '</tr>'.LF;

		foreach ( $daten_temp as $jahr=>$datensatz ){
			if ( $jahr%2 === 0 )
			$farbe = 'hell';
			else
			$farbe = 'dunkel';
		$report .= '<tr class="'.$farbe.'"><td>'.$jahr.'</td>';
			foreach ( $datensatz as $dekade=>$daten ){
				if ( $einstellungen['export']['konsolidierung_funktion'] === 'mittelwert' )
				$wert = array_sum($daten)/sizeof($daten);
				elseif ( $einstellungen['export']['konsolidierung_funktion'] === 'summe' )
				$wert = array_sum($daten);
			$report .= '<td>'.number_format($wert,1,',','.').'</td>'.LF;
			}
		$report .= '</tr>'.LF;
		}

	$report .= '</table>'.LF;
		if ( strlen($einstellungen['report']['lizenz_text']) > 20 ){
			if ( strlen($einstellungen['report']['lizenz_uri']) > 8 )
			$report .= '<a href="'.$einstellungen['report']['lizenz_uri'].'" target="_blank">'.htmlspecialchars($einstellungen['report']['lizenz_text']).'</a>'.LF;
			else
			$report .= htmlspecialchars($einstellungen['report']['lizenz_text']).LF;
		}
	$report .= '</body>'.LF;
	$report .= '</html>';
	break;

	case 'xml':
	$report .= '<?xml version="1.0" encoding="utf-8" standalone="yes"?>'.LF;
	$report .= '<export>'.LF;
		if ( !empty($einstellungen['export']['kommentar']) )
		$report .= '/* '.$einstellungen['export']['kommentar'].' */'.LF;
	$report .= '<meta>'.LF;
	$report .= chr(9).'<erstelltam>'.strftime(WADE_FDATE,time()).'</erstelltam>'.LF;
	$report .= chr(9).'<zeitraum>'.$DA->cli_parameter['vergleich'].'</zeitraum>'.LF;
	$report .= chr(9).'<name>'.htmlspecialchars($einstellungen['daten'][$DA->cli_parameter['station']]['name']).'</name>'.LF;
	$report .= chr(9).'<code>'.htmlspecialchars($einstellungen['daten'][$DA->cli_parameter['station']]['code']).'</code>'.LF;
	$report .= chr(9).'<datenquelle>'.htmlspecialchars($einstellungen['daten'][$DA->cli_parameter['station']]['quelle']).'</datenquelle>'.LF;
	$report .= '</meta>'.LF;
	$report .= '<lizenz>'.LF;
	$report .= chr(9).'<name>'.htmlspecialchars($einstellungen['report']['lizenz_text']).'</name>'.LF;
	$report .= chr(9).'<uri>'.$einstellungen['report']['lizenz_uri'].'</uri>'.LF;
	$report .= '</lizenz>'.LF;
	$report .= '<daten>'.LF;

		foreach ( $daten_temp as $jahr=>$datensatz ){
		$report .= chr(9).'<datensatz>'.LF;
		$report .= chr(9).chr(9).'<jahr>'.$jahr.'</jahr>'.LF;
			foreach ( $datensatz as $dekade=>$daten ){
				if ( $einstellungen['export']['konsolidierung_funktion'] === 'mittelwert' )
				$wert = array_sum($daten)/sizeof($daten);
				elseif ( $einstellungen['export']['konsolidierung_funktion'] === 'summe' )
				$wert = array_sum($daten);
			$dekaden_daten = explode('/',$dekade);
			$report .= chr(9).chr(9).'<dekade_'.str_replace('/','_',$dekade).' asstr="'.$DA->StrZahlNachMonat($dekaden_daten[0]).'/'.$dekaden_daten[1].'">'.number_format($wert,1,',','.').'</dekade_'.str_replace('/','_',$dekade).'>'.LF;
			}
		$report .= chr(9).'</datensatz>'.LF;
		}

	$report .= '</daten>';
	$report .= '</export>';
	break;
	}

	if ( !empty($einstellungen['report']['ausgabe_datei_maske']) && is_writeable(dirname($einstellungen['report']['ausgabe_datei_maske'])) )
	file_put_contents($einstellungen['report']['ausgabe_datei_maske'],$report);
$DA->KonsolenAusgabe('Export erstellt in "'.$einstellungen['report']['ausgabe_datei_maske'].'"',1);
$DA->KonsolenAusgabe('Aufgaben erledigt. Ciao!',0);

?>
